const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const goods_receipt_lines = sequelize.define(
    'goods_receipt_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

batch_code: {
        type: DataTypes.TEXT,
      
      

      },

expires_at: {
        type: DataTypes.DATE,
      
      

      },

quantity_received: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

line_total: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  goods_receipt_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























































//end loop



    db.goods_receipt_lines.belongsTo(db.goods_receipts, {
      as: 'goods_receipt',
      foreignKey: {
        name: 'goods_receiptId',
      },
      constraints: false,
    });

    db.goods_receipt_lines.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.goods_receipt_lines.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.goods_receipt_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.goods_receipt_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return goods_receipt_lines;
};


